Summary: GNU Compiler System
Name: gcc
Version: 3.0.1
Release: 1
Serial: 2
%define pro %{serial}:%{version}-%{release}
Group: Development/Languages
Copyright: GPL
Url: http://gcc.gnu.org/
Packager: Hao Li <hli@haoli.org>
Source: ftp://gcc.gnu.org/pub/gcc/releases/gcc-%{version}/gcc-%{version}.tar.bz2
Buildroot: /var/tmp/%{name}-root
Obsoletes: cpp, gcc-c++, gcc-chill, gcc-g77, gcc-java, gcc-objc, libstdc++, libstdc++-devel, compat-egcs, compat-egcs-c++, compat-egcs-g77, compat-egcs-objc
Provides: cpp = %{pro}, gcc-c++ = %{pro}, gcc-chill = %{pro}, gcc-g77 = %{pro}, gcc-java = %{pro}, gcc-objc = %{pro}, libstdc++ = %{pro}, libstdc++-devel = %{pro}

%description
A compiler aimed at integrating all the optimizations and features
necessary for a high-performance and stable development environment.

This package contains all the components of gcc, including c, c++, objc,
g77, chill and java. C++ shared libraries and headers which usually go
to libstdc++ and libstdc++-devel are also bundled in this package.


%prep
%setup -q


%build
rm -rf obj-i686-redhat-linux
mkdir  obj-i686-redhat-linux
cd     obj-i686-redhat-linux

CFLAGS='-O' \
LIBCFLAGS='-g -O2' \
LIBCXXFLAGS='-g -O2 -fno-implicit-templates' \
../configure \
	--prefix=/usr --enable-shared --enable-threads --disable-nls \
	i686-redhat-linux
make bootstrap-lean

# Remake info files with '--no-split'. Too tricky to do it above.
find .. -name \*.info\* -exec rm -f {} \;
make info MAKEINFOFLAGS='--no-split'


%install
rm -rf $RPM_BUILD_ROOT
cd obj-i686-redhat-linux
make prefix=$RPM_BUILD_ROOT/usr install

# Fix permission of several dynamic libraries
find $RPM_BUILD_ROOT/usr/lib -type f -name \*.so\* -exec chmod 755 {} \;

# Replace duplicated files with symlinks; also add some more symlinks
ln -sf i686-redhat-linux-g++	$RPM_BUILD_ROOT/usr/bin/i686-redhat-linux-c++
ln -sf i686-redhat-linux-c++	$RPM_BUILD_ROOT/usr/bin/c++
ln -sf i686-redhat-linux-g++	$RPM_BUILD_ROOT/usr/bin/g++
ln -sf i686-redhat-linux-gcc	$RPM_BUILD_ROOT/usr/bin/gcc
ln -sf gcc			$RPM_BUILD_ROOT/usr/bin/cc
ln -sf g77			$RPM_BUILD_ROOT/usr/bin/f77

ln -sf g++.1			$RPM_BUILD_ROOT/usr/man/man1/c++.1
ln -sf gcc.1			$RPM_BUILD_ROOT/usr/man/man1/cc.1
ln -sf g77.1			$RPM_BUILD_ROOT/usr/man/man1/f77.1

# /lib/cpp
mkdir -p $RPM_BUILD_ROOT/lib
ln -s ../usr/bin/cpp		$RPM_BUILD_ROOT/lib/cpp

# /usr/lib/libiberty.a is already provided by binutils
rm -f $RPM_BUILD_ROOT/usr/lib/libiberty.a


%define INFOFILES cpp cppinternals g77 gcc gcj

%post
/sbin/ldconfig
for i in %{INFOFILES}; do
  /sbin/install-info --info-dir=/usr/info /usr/info/$i.info.gz
done

%preun
if [ $1 = 0 ]; then
  for i in %{INFOFILES}; do
    /sbin/install-info --delete --info-dir=/usr/info /usr/info/$i.info.gz
  done
fi

%postun
/sbin/ldconfig


%files
%defattr(-,root,root)
%doc BUGS COPYING COPYING.LIB ChangeLog FAQ GNATS MAINTAINERS README 
%doc *.html INSTALL
/lib/cpp
/usr/bin/*
/usr/include/*
/usr/info/*
/usr/lib/*
/usr/man/man*/*
/usr/share/*


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Wed Jan  3 2001 Hao Li <hli@wag.caltech.edu>
- Decided to use /usr/lib/libiberty.a from binutils so this file from gcc 
  is removed.
